/*
** CDex - Open Source Digital Audio CD Extractor
**
** Copyright (C) 2006 - 2007 Georgy Berdyshev
** Copyright (C) 1999 - 2002 Albert L. Faber
**
** http://cdexos.sourceforge.net/
** http://sourceforge.net/projects/cdexos 
**
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include "TaskInfo.h"
#include "EncoderDosTta.h"
#include "EncoderDosTtaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

INITTRACE( _T( "EncoderDosTta" ) );


CEncoderDosTta::CEncoderDosTta():
	CEncoderDos()
{
	ENTRY_TRACE( _T( "CEncoderDosMpp::CEncoderDosTta()" ) );

	m_bRiffWavSupport = FALSE;
	m_strEncoderPath = _T( "" );
	m_nEncoderID = ENCODER_TTA;
	m_bOnTheFlyEncoding = FALSE;
	m_nUser2 = m_bNotUseTagFunc = FALSE;

	m_strUser1 = _T( "ttaenc.exe" );
	m_strUser2 = _T( "-e \"%1\" -o \"%2\"" );


	LoadSettings();

	if (m_strUser2 == _T( "" )) m_strUser2 = _T( "-e \"%1\" -o \"%2\"" );

	m_bSendStdinWavHeader = TRUE;
	m_strExtension = _T( "tta" );
	m_strEncoderID = _T( "External TTA Encoder" );

	m_bCanWriteTagV1 = TRUE;
	m_bCanWriteTagV2 = TRUE;

	SetChunkSupport ( FALSE ) ;

	EXIT_TRACE( _T( "CEncoderDosTta::CEncoderDosTta()" ) );
}

CEncoderDosTta::~CEncoderDosTta()
{
}

CEncoderDlg* CEncoderDosTta::GetSettingsDlg()
{
	if ( !m_pSettingsDlg )
	{
		m_pSettingsDlg = new CEncoderDosTTADlg;
	}
	return m_pSettingsDlg;
}


CDEX_ERR CEncoderDosTta::DosEncode(	const CUString& strInFileName,
									const CUString& strInFileExt, 
									const CUString& strOutFileName,
									const CUString& strOutDir,
									INT&  nPercent,
									BOOL& bAbort)
{
	CDEX_ERR bReturn = CDEX_OK;

	ENTRY_TRACE( _T( "CEncoderDosTta::DosEncode()" ) );

	// Call parent method
	bReturn = CEncoderDos::DosEncode(	strInFileName,
										strInFileExt,
										strOutFileName,
										strOutDir,
										nPercent,
										bAbort );

	EXIT_TRACE( _T( "CEncoderDosTta::DosEncode(), return value %d" ), bReturn );

	return bReturn;
}
